#include <iostream>
#include <stdlib.h>
#include <string>
#include <ukazatele.h>
#include <barvicky.h>

using namespace std;

int main (int argc, const char* argv[]) {
	cout << obarvi("*** Ukazatele ***", BARVA_ZELENA) << endl << endl;

	upravPromennou();
	cout << endl;
	zpracujParametry(argc, argv);
	
	cout << endl << obarvi("*** konec programu ***", BARVA_ZELENA) << endl;
	exit(0);
}

void upravPromennou() {
	int x;
	
	x = 100;
	upravSpatne(x);
	cout << obarvi("špatný výsledek: ", BARVA_ZELENA) << x << endl;
	
	x = 100;
	upravDobre(&x);
	cout << obarvi("dobrý výsledek:  ", BARVA_ZELENA) << x << endl;
	
	
	/** Nejde přeložit → error: invalid conversion from ‘int’ to ‘int*’ */
	//x = 100;
	//upravDobre(x);
	//cout << obarvi("dobrý výsledek:  ", BARVA_ZELENA) << x << endl;
	
	/** Nejde přeložit → error: invalid conversion from ‘int*’ to ‘int’ */
	//x = 100;
	//upravSpatne(&x);
	//cout << obarvi("špatný výsledek: ", BARVA_ZELENA) << x << endl;
}

/** Upravujeme pouze kopii hodnoty n – úprava platí jen v rámci této funkce */
void upravSpatne(int n) {
  n = 123;
}

/** Upravíme hodnotu v paměti, do které ukazuje *n – úprava platí globálně */
void upravDobre(int *n) {
  *n = 123;
}

void zpracujParametry(int argc, const char* argv[]) {
	cout << obarvi("Počet parametrů:  ", BARVA_ZELENA) << argc << ":" << endl;
	for (int i = 0; i < argc; i++) {
		cout << obarvi("Parametr:  ", BARVA_ZELENA) << argv[i] << endl;
	}	
}

